<center><a href="ex2f.F">Actual source code: ex2f.F</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:32:31+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>!
<a name="line2">  2: </a>!<font color="#B22222">/*T</font>
<a name="line3">  3: </a><font color="#B22222">!   Concepts: <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>^time-dependent nonlinear problems</font>
<a name="line4">  4: </a><font color="#B22222">!   Processors: n</font>
<a name="line5">  5: </a><font color="#B22222">!T*/</font>
<a name="line6">  6: </a>!
<a name="line7">  7: </a>!  ------------------------------------------------------------------------
<a name="line8">  8: </a>!
<a name="line9">  9: </a>!   This program solves a simple time-dependent nonlinear PDE using implicit
<a name="line10"> 10: </a>!   timestepping:
<a name="line11"> 11: </a>!                                    u * u_xx
<a name="line12"> 12: </a>!                              u_t = ---------
<a name="line13"> 13: </a>!                                    2*(t+1)^2
<a name="line14"> 14: </a>!
<a name="line15"> 15: </a>!             u(0,x) = 1 + x*x; u(t,0) = t + 1; u(t,1) = 2*t + 2
<a name="line16"> 16: </a>!
<a name="line17"> 17: </a>!   The exact solution is u(t,x) = (1 + x*x) * (1 + t).
<a name="line18"> 18: </a>!
<a name="line19"> 19: </a>!   Note that since the solution is linear in time and quadratic in x,
<a name="line20"> 20: </a>!   the finite difference scheme actually computes the <font color="#666666">"exact"</font> solution.
<a name="line21"> 21: </a>!
<a name="line22"> 22: </a>!   We use the backward Euler method.
<a name="line23"> 23: </a>!
<a name="line24"> 24: </a>!  --------------------------------------------------------------------------

<a name="line26"> 26: </a>      program main
<a name="line27"> 27: </a>      implicit none

<a name="line29"> 29: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line30"> 30: </a>!                    Include files
<a name="line31"> 31: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line32"> 32: </a>!
<a name="line33"> 33: </a>!  Each routine within this program uses the include file 'ex2f.h',
<a name="line34"> 34: </a>!  which itself includes the various PETSc include files as well as
<a name="line35"> 35: </a>!  problem-specific data in several common blocks.
<a name="line36"> 36: </a>!
<a name="line37"> 37: </a>!  This program uses CPP <font color="#4169E1">for</font> preprocessing, as indicated by the use of
<a name="line38"> 38: </a>!  PETSc include files in the directory petsc/include/finclude.  This
<a name="line39"> 39: </a>!  convention enables use of the CPP preprocessor, which allows the use
<a name="line40"> 40: </a>!  of the #include statements that define PETSc objects and variables.
<a name="line41"> 41: </a>!
<a name="line42"> 42: </a>!  Use of the conventional Fortran include statements is also supported
<a name="line43"> 43: </a>!  In this <font color="#4169E1">case</font>, the PETsc include files are located in the directory
<a name="line44"> 44: </a>!  petsc/include/foldinclude.
<a name="line45"> 45: </a>!
<a name="line46"> 46: </a>!  Since one must be very careful to include each file no more than once
<a name="line47"> 47: </a>!  in a Fortran routine, application programmers must exlicitly list
<a name="line48"> 48: </a>!  each file needed <font color="#4169E1">for</font> the various PETSc components within their
<a name="line49"> 49: </a>!  program (unlike the C/C++ interface).
<a name="line50"> 50: </a>!
<a name="line51"> 51: </a>!  See the Fortran section of the PETSc users manual <font color="#4169E1">for</font> details.

<a name="line53"> 53: </a><font color="#A020F0">#include </font><font color="#666666">"ex2f.h"</font><font color="#A020F0"></font>

<a name="line55"> 55: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line56"> 56: </a>!                   Variable declarations
<a name="line57"> 57: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line58"> 58: </a>!
<a name="line59"> 59: </a>!  Variables:
<a name="line60"> 60: </a>!     ts             - timestepping solver
<a name="line61"> 61: </a>!     A              - Jacobian matrix context
<a name="line62"> 62: </a>!     u_local        - local vector
<a name="line63"> 63: </a>!     u              - approximate solution vector
<a name="line64"> 64: </a>!     ftime          - final time
<a name="line65"> 65: </a>!     time_total_max - <font color="#4169E1">default</font> total max time
<a name="line66"> 66: </a>!     time_steps_max - <font color="#4169E1">default</font> max timesteps
<a name="line67"> 67: </a>!
<a name="line68"> 68: </a>!  Note that vectors are declared as PETSc <font color="#666666">"<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>"</font> objects.  These vectors
<a name="line69"> 69: </a>!  are mathematical objects that contain more than just an array of
<a name="line70"> 70: </a>!  double precision numbers. I.e., vectors in PETSc are not just
<a name="line71"> 71: </a>!        double precision x(*).
<a name="line72"> 72: </a>!  However, local vector data can be easily accessed via <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>().
<a name="line73"> 73: </a>!  See the Fortran section of the PETSc users manual <font color="#4169E1">for</font> details.

<a name="line75"> 75: </a>      <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>               ts
<a name="line76"> 76: </a>      <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>              u
<a name="line77"> 77: </a>      <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>              A
<a name="line78"> 78: </a>      <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>       flg,monitor
<a name="line79"> 79: </a>      <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
<a name="line80"> 80: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>  time_steps_max,steps,i1
<a name="line81"> 81: </a>      <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> dt,ftime,time_total_max

<a name="line83"> 83: </a>!  Note: Any user-defined Fortran routines (such as RHSFunction)
<a name="line84"> 84: </a>!  MUST be declared as external.

<a name="line86"> 86: </a>      external MyMonitor,RHSFunction
<a name="line87"> 87: </a>      external InitialConditions,RHSJacobian

<a name="line89"> 89: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line90"> 90: </a>!                 Beginning of program
<a name="line91"> 91: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line93"> 93: </a>      call <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(PETSC_NULL_CHARACTER,ierr)
<a name="line94"> 94: </a>      <A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A> = <A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>
<a name="line95"> 95: </a>      call <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>,ierr)
<a name="line96"> 96: </a>      call <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,ierr)

<a name="line98"> 98: </a>!  Initialize problem parameters

<a name="line100">100: </a>      time_steps_max = 1000
<a name="line101">101: </a>      time_total_max = 100.0
<a name="line102">102: </a>      m              = 60
<a name="line103">103: </a>      debug          = 0
<a name="line104">104: </a>      call <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(PETSC_NULL_CHARACTER,'-m',M,flg,ierr)
<a name="line105">105: </a>      call <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(PETSC_NULL_CHARACTER,'-debug',debug,ierr)
<a name="line106">106: </a>      call <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(PETSC_NULL_CHARACTER,'-monitor',monitor,       &amp;
<a name="line107">107: </a>     &amp;                         ierr)
<a name="line108">108: </a>      one_d0  = 1.0d0
<a name="line109">109: </a>      two_d0  = 2.0d0
<a name="line110">110: </a>      four_d0 = 4.0d0
<a name="line111">111: </a>      h       = one_d0/(m-one_d0)

<a name="line113">113: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line114">114: </a>!  Create vector data structures
<a name="line115">115: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line117">117: </a>!  Create distributed array (<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>) to manage parallel grid and vectors
<a name="line118">118: </a>!  Set up the ghost point communication pattern.  There are m total
<a name="line119">119: </a>!  grid values spread equally among all the processors.
<a name="line120">120: </a>      i1 = 1
<a name="line121">121: </a>      call <A href="../../../../docs/manualpages/DA/DACreate1d.html#DACreate1d">DACreate1d</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,DA_NONPERIODIC,m,i1,i1,                &amp;
<a name="line122">122: </a>     &amp;     PETSC_NULL_INTEGER,da,ierr)

<a name="line124">124: </a>!  Extract global and local vectors from <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>; then duplicate <font color="#4169E1">for</font> remaining
<a name="line125">125: </a>!  vectors that are the same types.

<a name="line127">127: </a>      call <A href="../../../../docs/manualpages/DA/DACreateGlobalVector.html#DACreateGlobalVector">DACreateGlobalVector</A>(da,u,ierr)
<a name="line128">128: </a>      call <A href="../../../../docs/manualpages/DA/DACreateLocalVector.html#DACreateLocalVector">DACreateLocalVector</A>(da,u_local,ierr)

<a name="line130">130: </a>!  Make local work vector <font color="#4169E1">for</font> evaluating right-hand-side function
<a name="line131">131: </a>      call <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(u_local,localwork,ierr)

<a name="line133">133: </a>!  Make global work vector <font color="#4169E1">for</font> storing exact solution
<a name="line134">134: </a>      call <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(u,solution,ierr)

<a name="line136">136: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line137">137: </a>!  Create timestepping solver context; set callback routine <font color="#4169E1">for</font>
<a name="line138">138: </a>!  right-hand-side function evaluation.
<a name="line139">139: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line141">141: </a>      call <A href="../../../../docs/manualpages/TS/TSCreate.html#TSCreate">TSCreate</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,ts,ierr)
<a name="line142">142: </a>      call <A href="../../../../docs/manualpages/TS/TSSetProblemType.html#TSSetProblemType">TSSetProblemType</A>(ts,TS_NONLINEAR,ierr)
<a name="line143">143: </a>      call <A href="../../../../docs/manualpages/TS/TSSetRHSFunction.html#TSSetRHSFunction">TSSetRHSFunction</A>(ts,RHSFunction,PETSC_NULL_OBJECT,ierr)

<a name="line145">145: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line146">146: </a>!  Set optional user-defined monitoring routine
<a name="line147">147: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


<a name="line150">150: </a>      <font color="#4169E1">if</font> (monitor .eq. 1) then
<a name="line151">151: </a>        call <A href="../../../../docs/manualpages/TS/TSSetMonitor.html#TSSetMonitor">TSSetMonitor</A>(ts,MyMonitor,PETSC_NULL_OBJECT,               &amp;
<a name="line152">152: </a>     &amp;                    PETSC_NULL_FUNCTION,ierr)
<a name="line153">153: </a>      endif

<a name="line155">155: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line156">156: </a>!  For nonlinear problems, the user can provide a Jacobian evaluation
<a name="line157">157: </a>!  routine (or use a finite differencing approximation).
<a name="line158">158: </a>!
<a name="line159">159: </a>!  Create matrix data structure; set Jacobian evaluation routine.
<a name="line160">160: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line162">162: </a>      call <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,A,ierr)
<a name="line163">163: </a>      call <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(A,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,m,m,ierr)
<a name="line164">164: </a>      call <A href="../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>(A,ierr)
<a name="line165">165: </a>      call <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(PETSC_NULL_CHARACTER,'-fdjac',flg,ierr)
<a name="line166">166: </a>      <font color="#4169E1">if</font> (flg .eq. 1) then
<a name="line167">167: </a>         call SetCRoutineFromFortran(ts,A,A,ierr)
<a name="line168">168: </a>      <font color="#4169E1">else</font>
<a name="line169">169: </a>         call <A href="../../../../docs/manualpages/TS/TSSetRHSJacobian.html#TSSetRHSJacobian">TSSetRHSJacobian</A>(ts,A,A,RHSJacobian,PETSC_NULL_OBJECT,    &amp;
<a name="line170">170: </a>     &amp;        ierr)
<a name="line171">171: </a>      endif

<a name="line173">173: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line174">174: </a>!  Set solution vector and initial timestep
<a name="line175">175: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line177">177: </a>      dt = h/two_d0
<a name="line178">178: </a>      call <A href="../../../../docs/manualpages/TS/TSSetInitialTimeStep.html#TSSetInitialTimeStep">TSSetInitialTimeStep</A>(ts,0.d0,dt,ierr)
<a name="line179">179: </a>      call <A href="../../../../docs/manualpages/TS/TSSetSolution.html#TSSetSolution">TSSetSolution</A>(ts,u,ierr)

<a name="line181">181: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line182">182: </a>!  Customize timestepping solver:
<a name="line183">183: </a>!     - Set the solution method to be the Backward Euler method.
<a name="line184">184: </a>!     - Set timestepping duration info
<a name="line185">185: </a>!  Then set runtime options, which can override these defaults.
<a name="line186">186: </a>!  For example,
<a name="line187">187: </a>!     -ts_max_steps &lt;maxsteps&gt; -ts_max_time &lt;maxtime&gt;
<a name="line188">188: </a>!  to override the defaults set by <A href="../../../../docs/manualpages/TS/TSSetDuration.html#TSSetDuration">TSSetDuration</A>().
<a name="line189">189: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line191">191: </a>      call <A href="../../../../docs/manualpages/TS/TSSetType.html#TSSetType">TSSetType</A>(ts,<A href="../../../../docs/manualpages/TS/TS_BEULER.html#TS_BEULER">TS_BEULER</A>,ierr)
<a name="line192">192: </a>      call <A href="../../../../docs/manualpages/TS/TSSetDuration.html#TSSetDuration">TSSetDuration</A>(ts,time_steps_max,time_total_max,ierr)
<a name="line193">193: </a>      call <A href="../../../../docs/manualpages/TS/TSSetFromOptions.html#TSSetFromOptions">TSSetFromOptions</A>(ts,ierr)

<a name="line195">195: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line196">196: </a>!  Solve the problem
<a name="line197">197: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line199">199: </a>!  Evaluate initial conditions

<a name="line201">201: </a>      call InitialConditions(u)

<a name="line203">203: </a>!  Run the timestepping solver

<a name="line205">205: </a>      call <A href="../../../../docs/manualpages/TS/TSStep.html#TSStep">TSStep</A>(ts,steps,ftime,ierr)

<a name="line207">207: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line208">208: </a>!  Free work space.  All PETSc objects should be destroyed when they
<a name="line209">209: </a>!  are no longer needed.
<a name="line210">210: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line212">212: </a>      call <A href="../../../../docs/manualpages/TS/TSDestroy.html#TSDestroy">TSDestroy</A>(ts,ierr)
<a name="line213">213: </a>      call <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(localwork,ierr)
<a name="line214">214: </a>      call <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(solution,ierr)
<a name="line215">215: </a>      call <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(u_local,ierr)
<a name="line216">216: </a>      call <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(u,ierr)
<a name="line217">217: </a>      call <A href="../../../../docs/manualpages/DA/DADestroy.html#DADestroy">DADestroy</A>(da,ierr)
<a name="line218">218: </a>      call <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A,ierr)

<a name="line220">220: </a>!  Always call <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>() before exiting a program.  This routine
<a name="line221">221: </a>!    - finalizes the PETSc libraries as well as MPI
<a name="line222">222: </a>!    - provides summary and diagnostic information <font color="#4169E1">if</font> certain runtime
<a name="line223">223: </a>!      options are chosen (e.g., -log_summary).

<a name="line225">225: </a>      call <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>(ierr)
<a name="line226">226: </a>      end

<a name="line228">228: </a>!  ------------------------------------------------------------------------
<a name="line229">229: </a>!
<a name="line230">230: </a>!  InitialConditions - Computes the solution at the initial time.
<a name="line231">231: </a>!
<a name="line232">232: </a>!  Input Parameters:
<a name="line233">233: </a>!     u - uninitialized solution vector (global)
<a name="line234">234: </a>!     appctx - user-defined application context
<a name="line235">235: </a>!
<a name="line236">236: </a>!  Output Parameter:
<a name="line237">237: </a>!     u - vector with solution at initial time (global)
<a name="line238">238: </a>!
<a name="line239">239: </a>      subroutine InitialConditions(u)
<a name="line240">240: </a>      implicit none
<a name="line241">241: </a><font color="#A020F0">#include </font><font color="#666666">"ex2f.h"</font><font color="#A020F0"></font>

<a name="line243">243: </a>!  Input/output parameters:
<a name="line244">244: </a>      <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>     u

<a name="line246">246: </a>!  Local variables:
<a name="line247">247: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> localptr(1),x
<a name="line248">248: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    i,mybase,myend
<a name="line249">249: </a>      <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
<a name="line250">250: </a>      PetscOffset idx

<a name="line252">252: </a>!  Determine starting and ending point of each processor's range of
<a name="line253">253: </a>!  grid values.  Note that we shift by 1 to convert from the 0-based
<a name="line254">254: </a>!  C convention of starting indices to the 1-based Fortran convention.

<a name="line256">256: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetOwnershipRange.html#VecGetOwnershipRange">VecGetOwnershipRange</A>(u,mybase,myend,ierr)
<a name="line257">257: </a>      mybase = mybase + 1

<a name="line259">259: </a>!  Get a pointer to vector data.
<a name="line260">260: </a>!    - For <font color="#4169E1">default</font> PETSc vectors, <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>() returns a pointer to
<a name="line261">261: </a>!      the data array.  Otherwise, the routine is implementation dependent.
<a name="line262">262: </a>!    - You MUST call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>() when you no longer need access to
<a name="line263">263: </a>!      the array.
<a name="line264">264: </a>!    - Note that the Fortran interface to <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>() differs from the
<a name="line265">265: </a>!      C version.  See the users manual <font color="#4169E1">for</font> details.

<a name="line267">267: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(u,localptr,idx,ierr)

<a name="line269">269: </a>!     We initialize the solution array by simply writing the solution
<a name="line270">270: </a>!     directly into the array locations.  Alternatively, we could use
<a name="line271">271: </a>!     <A href="../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>() or <A href="../../../../docs/manualpages/Vec/VecSetValuesLocal.html#VecSetValuesLocal">VecSetValuesLocal</A>().

<a name="line273">273: </a>      <font color="#4169E1">do</font> 10, i=mybase,myend
<a name="line274">274: </a>!       x - current location in global grid
<a name="line275">275: </a>        x = h*(i-1)
<a name="line276">276: </a>        localptr(i-mybase+idx+1) = one_d0 + x*x
<a name="line277">277: </a> 10   <font color="#4169E1">continue</font>

<a name="line279">279: </a>!  Restore vector

<a name="line281">281: </a>      call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(u,localptr,idx,ierr)

<a name="line283">283: </a>!  Print debugging information <font color="#4169E1">if</font> desired
<a name="line284">284: </a>      <font color="#4169E1">if</font> (debug .eq. 1) then
<a name="line285">285: </a>        <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0) write(6,*) 'initial guess vector'
<a name="line286">286: </a>        call <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(u,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>,ierr)
<a name="line287">287: </a>      endif

<a name="line289">289: </a>      <font color="#4169E1">return</font>
<a name="line290">290: </a>      end

<a name="line292">292: </a>!  ------------------------------------------------------------------------
<a name="line293">293: </a>!
<a name="line294">294: </a>!  ExactSolution - Computes the exact solution at a given time.
<a name="line295">295: </a>!
<a name="line296">296: </a>!  Input Parameters:
<a name="line297">297: </a>!    t - current time
<a name="line298">298: </a>!    appctx - user-defined application context
<a name="line299">299: </a>!
<a name="line300">300: </a>!  Output Parameter:
<a name="line301">301: </a>!    ierr - error code
<a name="line302">302: </a>!
<a name="line303">303: </a>!  Note: The solution vector is stored in the common block!
<a name="line304">304: </a>!
<a name="line305">305: </a>      subroutine ExactSolution(t,ierr)
<a name="line306">306: </a>      implicit none
<a name="line307">307: </a><font color="#A020F0">#include </font><font color="#666666">"ex2f.h"</font><font color="#A020F0"></font>

<a name="line309">309: </a>!  Input/output parameters:
<a name="line310">310: </a>      <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>  t
<a name="line311">311: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>  x
<a name="line312">312: </a>      <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>          ierr

<a name="line314">314: </a>!  Local variables:
<a name="line315">315: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> localptr(1)
<a name="line316">316: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    i,mybase,myend
<a name="line317">317: </a>      PetscOffset idx

<a name="line319">319: </a>!  Determine starting and ending point of each processors range of
<a name="line320">320: </a>!  grid values.  Note that we shift by 1 to convert from the 0-based
<a name="line321">321: </a>!  C convention of starting indices to the 1-based Fortran convention.

<a name="line323">323: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetOwnershipRange.html#VecGetOwnershipRange">VecGetOwnershipRange</A>(solution,mybase,myend,ierr)
<a name="line324">324: </a>      mybase = mybase + 1

<a name="line326">326: </a>!  Get a pointer to vector data
<a name="line327">327: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(solution,localptr,idx,ierr)

<a name="line329">329: </a>!  Simply write the solution directly into the array locations
<a name="line330">330: </a>!  Alternatively, we could use <A href="../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>() or <A href="../../../../docs/manualpages/Vec/VecSetValuesLocal.html#VecSetValuesLocal">VecSetValuesLocal</A>().

<a name="line332">332: </a>      <font color="#4169E1">do</font> 10, i=mybase,myend
<a name="line333">333: </a>!       x - current location in global grid
<a name="line334">334: </a>        x = h*(i-1)
<a name="line335">335: </a>        localptr(i-mybase+idx+1) = (t + one_d0)*(one_d0 + x*x)
<a name="line336">336: </a> 10   <font color="#4169E1">continue</font>

<a name="line338">338: </a>!  Restore vector

<a name="line340">340: </a>      call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(solution,localptr,idx,ierr)

<a name="line342">342: </a>      <font color="#4169E1">return</font>
<a name="line343">343: </a>      end

<a name="line345">345: </a>!  ------------------------------------------------------------------------
<a name="line346">346: </a>!
<a name="line347">347: </a>!   MyMonitor - A user-provided routine to monitor the solution computed at
<a name="line348">348: </a>!   each time-step.  This example plots the solution and computes the
<a name="line349">349: </a>!   error in two different norms.
<a name="line350">350: </a>!
<a name="line351">351: </a>!   Input Parameters:
<a name="line352">352: </a>!   ts     - the time-step context
<a name="line353">353: </a>!   step   - the count of the current step (with 0 meaning the
<a name="line354">354: </a>!            initial condition)
<a name="line355">355: </a>!   time   - the current time
<a name="line356">356: </a>!   u      - the solution at this timestep
<a name="line357">357: </a>!   dummy  - optional user-provided context <font color="#4169E1">for</font> this monitoring
<a name="line358">358: </a>!            routine (not used here)
<a name="line359">359: </a>!
<a name="line360">360: </a>      subroutine MyMonitor(ts,step,time,u,dummy,ierr)
<a name="line361">361: </a>      implicit none
<a name="line362">362: </a><font color="#A020F0">#include </font><font color="#666666">"ex2f.h"</font><font color="#A020F0"></font>

<a name="line364">364: </a>!  Input/output parameters:
<a name="line365">365: </a>      <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>       ts
<a name="line366">366: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> step
<a name="line367">367: </a>      <A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A> dummy
<a name="line368">368: </a>      <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> time
<a name="line369">369: </a>      <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>      u
<a name="line370">370: </a>      <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr

<a name="line372">372: </a>!  Local variables:
<a name="line373">373: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> en2,en2s,enmax
<a name="line374">374: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> mone
<a name="line375">375: </a>      <A href="../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A>   draw

<a name="line377">377: </a>      mone = -1.0d0

<a name="line379">379: </a>!  We use the <font color="#4169E1">default</font> X windows viewer
<a name="line380">380: </a>!       <A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_DRAW_WORLD.html#PETSC_VIEWER_DRAW_WORLD">PETSC_VIEWER_DRAW_WORLD</A>
<a name="line381">381: </a>!  that is associated with the <A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A> communicator. This
<a name="line382">382: </a>!  saves the effort of calling <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>() to create the window.
<a name="line383">383: </a>!  Note that <font color="#4169E1">if</font> we wished to plot several items in separate windows we
<a name="line384">384: </a>!  would create each viewer with <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>() and store them in
<a name="line385">385: </a>!  the application context, appctx.
<a name="line386">386: </a>!
<a name="line387">387: </a>!  Double buffering makes graphics look better.

<a name="line389">389: </a>      call <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>(<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_DRAW_WORLD.html#PETSC_VIEWER_DRAW_WORLD">PETSC_VIEWER_DRAW_WORLD</A>,0,draw,ierr)
<a name="line390">390: </a>      call <A href="../../../../docs/manualpages/Draw/PetscDrawSetDoubleBuffer.html#PetscDrawSetDoubleBuffer">PetscDrawSetDoubleBuffer</A>(draw,ierr)
<a name="line391">391: </a>      call <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(u,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_DRAW_WORLD.html#PETSC_VIEWER_DRAW_WORLD">PETSC_VIEWER_DRAW_WORLD</A>,ierr)

<a name="line393">393: </a>!  Compute the exact solution at this time-step.  Note that the
<a name="line394">394: </a>!  solution vector is passed via the user-defined common block.
<a name="line395">395: </a>      call ExactSolution(time,ierr)

<a name="line397">397: </a>!  Print debugging information <font color="#4169E1">if</font> desired
<a name="line398">398: </a>      <font color="#4169E1">if</font> (debug .eq. 1) then
<a name="line399">399: </a>        <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0) write(6,*) 'Computed solution vector'
<a name="line400">400: </a>        call <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(u,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>,ierr)
<a name="line401">401: </a>        <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0) write(6,*) 'Exact solution vector'
<a name="line402">402: </a>        call <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(solution,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>,ierr)
<a name="line403">403: </a>      endif

<a name="line405">405: </a>!  Compute the 2-norm and max-norm of the error
<a name="line406">406: </a>      call <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(solution,mone,u,ierr)
<a name="line407">407: </a>      call <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(solution,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,en2,ierr)

<a name="line409">409: </a>!  Scale the 2-norm by the grid spacing
<a name="line410">410: </a>      en2s = dsqrt(h)*en2
<a name="line411">411: </a>      call <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(solution,<A href="../../../../docs/manualpages/Vec/NORM_MAX.html#NORM_MAX">NORM_MAX</A>,enmax,ierr)

<a name="line413">413: </a>!  Print only from processor 0
<a name="line414">414: </a>      <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0) write(6,100) step,time,en2s,enmax
<a name="line415">415: </a> 100  format('Timestep = ',i5,',time = ',f8.3,                          &amp;
<a name="line416">416: </a>     &amp;       ' sec, error [2-norm] = ',e9.3,                            &amp;
<a name="line417">417: </a>     &amp;       ', error [max-norm] = ',e9.3)

<a name="line419">419: </a>!  Print debugging information <font color="#4169E1">if</font> desired
<a name="line420">420: </a>      <font color="#4169E1">if</font> (debug .eq. 1) then
<a name="line421">421: </a>        <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0) write(6,*) 'Error vector'
<a name="line422">422: </a>        call <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(solution,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>,ierr)
<a name="line423">423: </a>      endif

<a name="line425">425: </a>      <font color="#4169E1">return</font>
<a name="line426">426: </a>      end

<a name="line428">428: </a>!  ------------------------------------------------------------------------
<a name="line429">429: </a>!
<a name="line430">430: </a>!   RHSFunction - User-provided routine that evalues the RHS function
<a name="line431">431: </a>!   in the ODE.  This routine is set in the main program by calling
<a name="line432">432: </a>!   <A href="../../../../docs/manualpages/TS/TSSetRHSFunction.html#TSSetRHSFunction">TSSetRHSFunction</A>().  We compute:
<a name="line433">433: </a>!         global_out = F(global_in)
<a name="line434">434: </a>!
<a name="line435">435: </a>!   Input Parameters:
<a name="line436">436: </a>!      ts         - timestep context
<a name="line437">437: </a>!      t          - current time
<a name="line438">438: </a>!      global_in  - input vector to function
<a name="line439">439: </a>!      dummy      - (optional) user-provided context <font color="#4169E1">for</font> function evaluation
<a name="line440">440: </a>!                   (not used here because we use a common block instead)
<a name="line441">441: </a>!
<a name="line442">442: </a>!   Output Parameter:
<a name="line443">443: </a>!      global_out - value of function
<a name="line444">444: </a>!
<a name="line445">445: </a>      subroutine RHSFunction(ts,t,global_in,global_out,dummy)
<a name="line446">446: </a>      implicit none
<a name="line447">447: </a><font color="#A020F0">#include </font><font color="#666666">"ex2f.h"</font><font color="#A020F0"></font>

<a name="line449">449: </a>!  Input/output parameters:
<a name="line450">450: </a>      <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>        ts
<a name="line451">451: </a>      <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t
<a name="line452">452: </a>      <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>       global_in,global_out
<a name="line453">453: </a>      integer   dummy

<a name="line455">455: </a>!  Local variables:
<a name="line456">456: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> localptr(1),copyptr(1),sc
<a name="line457">457: </a>      <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
<a name="line458">458: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    i,localsize
<a name="line459">459: </a>      PetscOffset idx_c,idx_l,il

<a name="line461">461: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line462">462: </a>!  Get ready <font color="#4169E1">for</font> local function computations
<a name="line463">463: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line465">465: </a>!  Scatter ghost points to local vector, using the 2-step process
<a name="line466">466: </a>!     <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(), <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>().
<a name="line467">467: </a>!  By placing code between these two statements, computations can be
<a name="line468">468: </a>!  done <font color="#4169E1">while</font> messages are in transition.

<a name="line470">470: </a>      call <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(da,global_in,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,u_local,ierr)
<a name="line471">471: </a>      call <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(da,global_in,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,u_local,ierr)

<a name="line473">473: </a>!  Access directly the values in our local INPUT work vector
<a name="line474">474: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(u_local,localptr,idx_l,ierr)

<a name="line476">476: </a>!  Access directly the values in our local OUTPUT work vector
<a name="line477">477: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(localwork,copyptr,idx_c,ierr)

<a name="line479">479: </a>      sc = one_d0/(h*h*two_d0*(one_d0+t)*(one_d0+t))

<a name="line481">481: </a>!  Evaluate our function on the nodes owned by this processor
<a name="line482">482: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetLocalSize.html#VecGetLocalSize">VecGetLocalSize</A>(u_local,localsize,ierr)

<a name="line484">484: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line485">485: </a>!  Compute entries <font color="#4169E1">for</font> the locally owned part
<a name="line486">486: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line488">488: </a>!  Handle boundary conditions: This is done by using the boundary condition
<a name="line489">489: </a>!        u(t,boundary) = g(t,boundary)
<a name="line490">490: </a>!  <font color="#4169E1">for</font> some function g. Now take the derivative with respect to t to obtain
<a name="line491">491: </a>!        u_{t}(t,boundary) = g_{t}(t,boundary)
<a name="line492">492: </a>!
<a name="line493">493: </a>!  In our <font color="#4169E1">case</font>, u(t,0) = t + 1, so that u_{t}(t,0) = 1
<a name="line494">494: </a>!          and  u(t,1) = 2t+ 1, so that u_{t}(t,1) = 2

<a name="line496">496: </a>       <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0)      copyptr(1+idx_c) = one_d0
<a name="line497">497: </a>       <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>-1) copyptr(localsize+idx_c) = two_d0

<a name="line499">499: </a>!  Handle the interior nodes where the PDE is replace by finite
<a name="line500">500: </a>!  difference operators.

<a name="line502">502: </a>      <font color="#4169E1">do</font> 10, i=2,localsize-1
<a name="line503">503: </a>         il = i + idx_l
<a name="line504">504: </a>         copyptr(i+idx_c) =  localptr(il) * sc *                        &amp;
<a name="line505">505: </a>     &amp;     (localptr(il+1) + localptr(il-1) - two_d0*localptr(il))
<a name="line506">506: </a> 10   <font color="#4169E1">continue</font>

<a name="line508">508: </a>      call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(u_local,localptr,idx_l,ierr)
<a name="line509">509: </a>      call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(localwork,copyptr,idx_c,ierr)

<a name="line511">511: </a>!  Return the values from our local OUTPUT vector into our global
<a name="line512">512: </a>!  output vector.

<a name="line514">514: </a>      call <A href="../../../../docs/manualpages/DA/DALocalToGlobal.html#DALocalToGlobal">DALocalToGlobal</A>(da,localwork,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,global_out,ierr)

<a name="line516">516: </a>!  Print debugging information <font color="#4169E1">if</font> desired
<a name="line517">517: </a>      <font color="#4169E1">if</font> (debug .eq. 1) then
<a name="line518">518: </a>        <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> .eq. 0) write(6,*) 'RHS function vector'
<a name="line519">519: </a>        call <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(global_out,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>,ierr)
<a name="line520">520: </a>      endif

<a name="line522">522: </a>      <font color="#4169E1">return</font>
<a name="line523">523: </a>      end

<a name="line525">525: </a>!  ------------------------------------------------------------------------
<a name="line526">526: </a>!
<a name="line527">527: </a>!  RHSJacobian - User-provided routine to compute the Jacobian of the
<a name="line528">528: </a>!                right-hand-side function.
<a name="line529">529: </a>!
<a name="line530">530: </a>!  Input Parameters:
<a name="line531">531: </a>!     ts - the <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> context
<a name="line532">532: </a>!     t - current time
<a name="line533">533: </a>!     global_in - global input vector
<a name="line534">534: </a>!     dummy - optional user-defined context, as set by TSetRHSJacobian()
<a name="line535">535: </a>!
<a name="line536">536: </a>!  Output Parameters:
<a name="line537">537: </a>!     A - Jacobian matrix
<a name="line538">538: </a>!     B - optionally different preconditioning matrix
<a name="line539">539: </a>!     str - flag indicating matrix structure
<a name="line540">540: </a>!
<a name="line541">541: </a>!  Notes:
<a name="line542">542: </a>!  RHSJacobian computes entries <font color="#4169E1">for</font> the locally owned part of the Jacobian.
<a name="line543">543: </a>!   - Currently, all PETSc parallel matrix formats are partitioned by
<a name="line544">544: </a>!     contiguous chunks of rows across the processors. The <font color="#666666">"grow"</font>
<a name="line545">545: </a>!     parameter computed below specifies the global row number
<a name="line546">546: </a>!     corresponding to each local grid point.
<a name="line547">547: </a>!   - Each processor needs to insert only elements that it owns
<a name="line548">548: </a>!     locally (but any non-local elements will be sent to the
<a name="line549">549: </a>!     appropriate processor during matrix assembly).
<a name="line550">550: </a>!   - Always specify global row and columns of matrix entries.
<a name="line551">551: </a>!   - Here, we set all entries <font color="#4169E1">for</font> a particular row at once.
<a name="line552">552: </a>!   - Note that <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>() uses 0-based row and column numbers
<a name="line553">553: </a>!     in Fortran as well as in C.

<a name="line555">555: </a>      subroutine RHSJacobian(ts,t,global_in,A,B,str,dummy)
<a name="line556">556: </a>      implicit none
<a name="line557">557: </a><font color="#A020F0">#include </font><font color="#666666">"ex2f.h"</font><font color="#A020F0"></font>

<a name="line559">559: </a>!  Input/output parameters:
<a name="line560">560: </a>      <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>               ts
<a name="line561">561: </a>      <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t
<a name="line562">562: </a>      <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>              global_in
<a name="line563">563: </a>      <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>              A,B
<a name="line564">564: </a>      <A href="../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>     str
<a name="line565">565: </a>      integer          dummy

<a name="line567">567: </a>!  Local variables:
<a name="line568">568: </a>      <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> localptr(1),sc,v(3)
<a name="line569">569: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    i,col(3),i1,i3
<a name="line570">570: </a>      <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
<a name="line571">571: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    mstart(1),mend(1)
<a name="line572">572: </a>      <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    mstarts,mends
<a name="line573">573: </a>      PetscOffset idx,is

<a name="line575">575: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line576">576: </a>!  Get ready <font color="#4169E1">for</font> local Jacobian computations
<a name="line577">577: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line579">579: </a>!  Scatter ghost points to local vector, using the 2-step process
<a name="line580">580: </a>!     <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(), <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>().
<a name="line581">581: </a>!  By placing code between these two statements, computations can be
<a name="line582">582: </a>!  done <font color="#4169E1">while</font> messages are in transition.

<a name="line584">584: </a>      call <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(da,global_in,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,u_local,ierr)
<a name="line585">585: </a>      call <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(da,global_in,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,u_local,ierr)

<a name="line587">587: </a>!  Get pointer to vector data
<a name="line588">588: </a>      call <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(u_local,localptr,idx,ierr)

<a name="line590">590: </a>!  Get starting and ending locally owned rows of the matrix
<a name="line591">591: </a>      call <A href="../../../../docs/manualpages/Mat/MatGetOwnershipRange.html#MatGetOwnershipRange">MatGetOwnershipRange</A>(A,mstarts,mends,ierr)
<a name="line592">592: </a>      mstart(1) = mstarts
<a name="line593">593: </a>      mend(1)   = mends

<a name="line595">595: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line596">596: </a>!  Compute entries <font color="#4169E1">for</font> the locally owned part of the Jacobian.
<a name="line597">597: </a>!   - Currently, all PETSc parallel matrix formats are partitioned by
<a name="line598">598: </a>!     contiguous chunks of rows across the processors.
<a name="line599">599: </a>!   - Each processor needs to insert only elements that it owns
<a name="line600">600: </a>!     locally (but any non-local elements will be sent to the
<a name="line601">601: </a>!     appropriate processor during matrix assembly).
<a name="line602">602: </a>!   - Here, we set all entries <font color="#4169E1">for</font> a particular row at once.
<a name="line603">603: </a>!   - We can set matrix entries either using either
<a name="line604">604: </a>!     <A href="../../../../docs/manualpages/Mat/MatSetValuesLocal.html#MatSetValuesLocal">MatSetValuesLocal</A>() or <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>().
<a name="line605">605: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line607">607: </a>!  Set matrix rows corresponding to boundary data
<a name="line608">608: </a>      i1 = 1
<a name="line609">609: </a>      i3 = 3
<a name="line610">610: </a>      <font color="#4169E1">if</font> (mstart(1) .eq. 0) then
<a name="line611">611: </a>        v(1) = zero_d0
<a name="line612">612: </a>        call <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,i1,mstart,i1,mstart,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,ierr)
<a name="line613">613: </a>        mstart(1) = mstart(1) + 1
<a name="line614">614: </a>      endif
<a name="line615">615: </a>      <font color="#4169E1">if</font> (mend(1) .eq. m) then
<a name="line616">616: </a>        mend(1) = mend(1) - 1
<a name="line617">617: </a>        v(1) = zero_d0
<a name="line618">618: </a>        call <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,i1,mend,i1,mend,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,ierr)
<a name="line619">619: </a>      endif

<a name="line621">621: </a>!  Set matrix rows corresponding to interior data.
<a name="line622">622: </a>!  We construct the matrix one row at a time.

<a name="line624">624: </a>      sc = one_d0/(h*h*two_d0*(one_d0+t)*(one_d0+t))
<a name="line625">625: </a>      <font color="#4169E1">do</font> 10, i=mstart(1),mend(1)-1
<a name="line626">626: </a>         col(1) = i-1
<a name="line627">627: </a>         col(2) = i
<a name="line628">628: </a>         col(3) = i+1
<a name="line629">629: </a>         is     = i - mstart(1) + 1 +idx + 1
<a name="line630">630: </a>         v(1)   = sc*localptr(is)
<a name="line631">631: </a>         v(2)   = sc*(localptr(is+1) + localptr(is-1) -                 &amp;
<a name="line632">632: </a>     &amp;                four_d0*localptr(is))
<a name="line633">633: </a>         v(3)   = sc*localptr(is)
<a name="line634">634: </a>        call <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,i1,i,i3,col,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,ierr)
<a name="line635">635: </a> 10   <font color="#4169E1">continue</font>

<a name="line637">637: </a>!  Restore vector
<a name="line638">638: </a>      call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(u_local,localptr,idx,ierr)

<a name="line640">640: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
<a name="line641">641: </a>!  Complete the matrix assembly process and set some options
<a name="line642">642: </a>! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

<a name="line644">644: </a>!  Assemble matrix, using the 2-step process:
<a name="line645">645: </a>!       <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(), <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>()
<a name="line646">646: </a>!  Computations can be done <font color="#4169E1">while</font> messages are in transition,
<a name="line647">647: </a>!  by placing code between these two statements.

<a name="line649">649: </a>      call <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(A,MAT_FINAL_ASSEMBLY,ierr)
<a name="line650">650: </a>      call <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(A,MAT_FINAL_ASSEMBLY,ierr)

<a name="line652">652: </a>!  Set flag to indicate that the Jacobian matrix retains an identical
<a name="line653">653: </a>!  nonzero structure throughout all timestepping iterations (although the
<a name="line654">654: </a>!  values of the entries change). Thus, we can save some work in setting
<a name="line655">655: </a>!  up the preconditioner (e.g., no need to redo symbolic factorization <font color="#4169E1">for</font>
<a name="line656">656: </a>!  ILU/ICC preconditioners).
<a name="line657">657: </a>!   - If the nonzero structure of the matrix is different during
<a name="line658">658: </a>!     successive linear solves, then the flag DIFFERENT_NONZERO_PATTERN
<a name="line659">659: </a>!     must be used instead.  If you are unsure whether the matrix
<a name="line660">660: </a>!     structure has changed or not, use the flag DIFFERENT_NONZERO_PATTERN.
<a name="line661">661: </a>!   - Caution:  If you specify SAME_NONZERO_PATTERN, PETSc
<a name="line662">662: </a>!     believes your assertion and does not check the structure
<a name="line663">663: </a>!     of the matrix.  If you erroneously claim that the structure
<a name="line664">664: </a>!     is the same when it actually is not, the new preconditioner
<a name="line665">665: </a>!     will not function correctly.  Thus, use this optimization
<a name="line666">666: </a>!     feature with caution!

<a name="line668">668: </a>      str = SAME_NONZERO_PATTERN

<a name="line670">670: </a>!  Set and option to indicate that we will never add a new nonzero location
<a name="line671">671: </a>!  to the matrix. If we <font color="#4169E1">do</font>, it will generate an error.

<a name="line673">673: </a>      call <A href="../../../../docs/manualpages/Mat/MatSetOption.html#MatSetOption">MatSetOption</A>(A,MAT_NEW_NONZERO_LOCATION_ERR,ierr)

<a name="line675">675: </a>      <font color="#4169E1">return</font>
<a name="line676">676: </a>      end
</pre>
</body>

</html>
